using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Web.UI;


[assembly: WebResource("SlAjaxSphere.SilverlightAjaxSphere.js", "text/javascript")]
[assembly: WebResource("SlAjaxSphere.Silverlight.js", "text/javascript")]
[assembly: WebResource("SlAjaxSphere.Sphere.xaml", "text/xml")]

namespace Pluralsight
{

  public class SilverlightAjaxSphere : Control, IScriptControl
  {
    public string Title
    {
      get { return (string)(ViewState["title"] ?? "[title]"); }
      set { ViewState["title"] = value; }
    }

    public string XamlUrl
    {
      get { return (string)(ViewState["xamlurl"] ?? string.Empty); }
      set { ViewState["xamlurl"] = value; }
    }

    protected override void OnInit(EventArgs e)
    {
      // Default the XamlUrl to our embedded resource, if it is set in the
      // markup explicitly, this will be overridden.
      XamlUrl = Page.ClientScript.GetWebResourceUrl(GetType(), "SlAjaxSphere.Sphere.xaml");

      base.OnInit(e);
    }

    public IEnumerable<ScriptDescriptor> GetScriptDescriptors()
    {
      ScriptControlDescriptor scd = new ScriptControlDescriptor("Pluralsight.SilverlightAjaxSphere",
        this.ClientID);
      scd.AddProperty("title", this.Title);
      scd.AddProperty("xamlUrl", this.XamlUrl);

      return new ScriptDescriptor[] { scd };
    }

    public IEnumerable<ScriptReference> GetScriptReferences()
    {
      ScriptReference sr1 = new ScriptReference("SlAjaxSphere.Silverlight.js",
        GetType().Assembly.FullName);
     ScriptReference sr2 = new ScriptReference("SlAjaxSphere.SilverlightAjaxSphere.js",
        GetType().Assembly.FullName);

      return new ScriptReference[] { sr1, sr2 };
    }

    protected override void OnPreRender(EventArgs e)
    {
      if (!DesignMode)
      {
        ScriptManager sm = ScriptManager.GetCurrent(Page);
        if (sm == null)
          throw new HttpException("A ScriptManager control must exist on the current page.");

        sm.RegisterScriptControl(this);
        sm.RegisterScriptDescriptors(this);
      }

      base.OnPreRender(e);
    }

    protected override void Render(HtmlTextWriter writer)
    {
      writer.AddAttribute(HtmlTextWriterAttribute.Id, this.ClientID);
      writer.RenderBeginTag(HtmlTextWriterTag.Div);
      writer.RenderEndTag();

      base.Render(writer);
    }
  }

}

