using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.Web.Preview.UI.Controls;

[assembly: WebResource("SlXamlSphere.Sphere.xaml", "text/xml")]
[assembly: WebResource("SlXamlSphere.SilverlightXamlSphere.js", "text/javascript")]

namespace Pluralsight
{
  public class SilverlightXamlSphere : Xaml
  {
    public string Title
    {
      get { return (string)(ViewState["title"] ?? "[title]"); }
      set { ViewState["title"] = value; }
    }

    protected override void OnInit(EventArgs e)
    {
      // Initialize XamlUrl to embedded Xaml here - it will be overridden if set explicitly
      this.XamlUrl = Page.ClientScript.GetWebResourceUrl(this.GetType(),
                                                    "SlXamlSphere.Sphere.xaml");
      this.ClientType = "Pluralsight.SilverlightXamlSphere";
      this.Width = new Unit(300, UnitType.Pixel);
      this.Height = new Unit(300, UnitType.Pixel);

      base.OnInit(e);
    }

    protected override IEnumerable<ScriptReference> GetScriptReferences()
    {
      List<ScriptReference> ret = new List<ScriptReference>(base.GetScriptReferences());
      ret.Add(new ScriptReference("SlXamlSphere.SilverlightXamlSphere.js",
                                  this.GetType().Assembly.FullName));

      return ret;
    }

    protected override IEnumerable<ScriptDescriptor> GetScriptDescriptors()
    {
      IEnumerable<ScriptDescriptor> descriptors = base.GetScriptDescriptors();

      foreach (ScriptControlDescriptor descriptor in descriptors)
      {
        descriptor.AddProperty("title", this.Title);
        return new ScriptDescriptor[] { descriptor };
      }

      return null;
    }

  }
}

