﻿Type.registerNamespace('Pluralsight');

Pluralsight.SilverlightXamlSphere = function(element) {
    Pluralsight.SilverlightXamlSphere.initializeBase(this, [element]);
    
    this._title = null;
}

Pluralsight.SilverlightXamlSphere.prototype = {
    initialize : function() {
        Pluralsight.SilverlightXamlSphere.callBaseMethod(this, 'initialize');        
    },
    
    xamlInitialize : function() {
      var rootElement = this.get_element();
      // Wire up event handlers
      this._onSphereButtonDown = Function.createDelegate(this, this._onSphereButtonDown);
      
      var sphere = rootElement.Content.FindName('ellipse');
      if (sphere) {
        sphere.addEventListener('MouseLeftButtonDown', 
                    Function.createDelegate(this, this._onSphereButtonDown));
      }        
      else
        alert('Xaml must have an ellipse element for this control to work');
        
      var title = rootElement.Content.FindName('titleText');
      if (title)
        title.Text = this._title;
    },

    dispose : function() {
        Pluralsight.SilverlightXamlSphere.callBaseMethod(this, 'dispose');
    },
     
    _onSphereButtonDown : function(sender, args)
    {
      // Run the grow or shrink animation, depending on whether it is currently
      // 'grown' or 'shrunk'
      var animationName = (sender.Width==200) ? "growAnimation" : "shrinkAnimation";
      
      var sl = sender.GetHost();
      var animation = sl.Content.FindName(animationName);
      if (animation)
        animation.begin();
    },

     // property accessors
    //
    get_title : function() {
        return this._title;
    },

    set_title : function(value) {
        if (this._title !== value) {
            this._title = value;            
        }
    }
}

Pluralsight.SilverlightXamlSphere.registerClass('Pluralsight.SilverlightXamlSphere', Sys.Preview.UI.Xaml.Control);

if (typeof(Sys) !== 'undefined') Sys.Application.notifyScriptLoaded();
