using System;
using System.Collections.Generic;
using System.Text;
using System.Web.UI;
using System.Web;

[assembly: WebResource("ClassLibrary1.Silverlight.js", "text/javascript")]
[assembly: WebResource("ClassLibrary1.Sphere.xaml", "text/xml")]
[assembly: WebResource("ClassLibrary1.Sphere.xaml.js", "text/javascript")]

namespace ClassLibrary1
{
    public class MyXamlControl : Control, IScriptControl
    {
        protected override void OnInit(EventArgs e)
        {
            XamlUrl = Page.ClientScript.GetWebResourceUrl(GetType(),
                "ClassLibrary1.Sphere.xaml");
            base.OnInit(e);
        }

        public string Title
        {
            get { return (string)(ViewState["title"] ?? "[title]"); }
            set { ViewState["title"] = value; }
        }

        public string XamlUrl
        {
            get { return (string)(ViewState["xamlurl"] ?? string.Empty); }
            set { ViewState["xamlurl"] = value; }
        }

        protected override void Render(HtmlTextWriter writer)
        {
            writer.AddAttribute(HtmlTextWriterAttribute.Id, this.ClientID);
            writer.RenderBeginTag(HtmlTextWriterTag.Div);
            writer.RenderEndTag();

            base.Render(writer);
        }

        protected override void OnPreRender(EventArgs e)
        {
            if (!DesignMode)
            {
                ScriptManager sm = ScriptManager.GetCurrent(Page);
                if (sm == null)
                    throw new HttpException("Missing ScriptManager.");

                sm.RegisterScriptControl(this);
                sm.RegisterScriptDescriptors(this);
            }
            base.OnPreRender(e);
        }


        #region IScriptControl Members


        public IEnumerable<ScriptReference> GetScriptReferences()
        {
            ScriptReference sr1 = new ScriptReference("ClassLibrary1.Silverlight.js",
                  GetType().Assembly.FullName);
            ScriptReference sr2 = new ScriptReference("ClassLibrary1.Sphere.xaml.js",
                  GetType().Assembly.FullName);
            return new ScriptReference[] { sr1, sr2 };
        }

        public IEnumerable<ScriptDescriptor> GetScriptDescriptors()
        {
            ScriptControlDescriptor scd =
              new ScriptControlDescriptor("Pluralsight.SilverlightAjaxSphere",
                            this.ClientID);

            scd.AddProperty("title", this.Title);
            scd.AddProperty("xamlUrl", this.XamlUrl);
            return new ScriptDescriptor[] { scd };
        }

        #endregion
    }
}
