if (!window.MyControls)
	window.MyControls = {};

MyControls.NextId = 1;

MyControls.Button = function(silverlightPlugIn, onLoaded) 
{
    this._clickHandlers = [];
    
    var thisButton = this;
    var downloader = silverlightPlugIn.CreateObject("Downloader");
    var listenerToken = downloader.AddEventListener("Completed", DownloadComplete);
    downloader.Open("GET", "Button.xaml");
    downloader.Send();
    
    function DownloadComplete(sender, eventArgs)
    {
        var controlXaml = downloader.GetResponseText("");
        downloader.RemoveEventListener("Completed", listenerToken);

        var namePrefix = "MyButton_" + MyControls.NextId++;
        controlXaml = controlXaml.replace(/Name=(["'])/gm, "Name=\"" + namePrefix);
        var controlContent = silverlightPlugIn.Content.CreateFromXaml(controlXaml);

        var eventArgs = { Content: controlContent };
        thisButton.handleLoad(silverlightPlugIn, controlContent, namePrefix);
        onLoaded(thisButton, eventArgs);
    }
}

MyControls.Button.prototype =
{
	handleLoad: function(plugIn, rootElement, namePrefix)
	{
		this.plugIn = plugIn;
		this._root = rootElement;
		this._namePrefix = namePrefix;
		
		// Sample button event hookup: Find the button and then attach event handlers
		this.button = rootElement.children.getItem(0);	
		
		this.button.addEventListener("MouseEnter", Silverlight.createDelegate(this, this.handleMouseEnter));
		this.button.addEventListener("MouseLeftButtonDown", Silverlight.createDelegate(this, this.handleMouseDown));
		this.button.addEventListener("MouseLeftButtonUp", Silverlight.createDelegate(this, this.handleMouseUp));
		this.button.addEventListener("MouseLeave", Silverlight.createDelegate(this, this.handleMouseLeave));
	},
	
	SetText: function(text)
    {
        var textBlock = this._root.findName(this._namePrefix + "caption");
        textBlock.Text = text;
    },
    
    AddEventListener: function(name, handler)
    {
      switch(name)
      {
        case "Click":
          if  (this._clickHandlers)
          {
            this._clickHandlers.push(handler);
          }
          else
          {
            this._clickHandlers = [handler];
          }
          return this._clickHandlers.length;
    
        default:
          throw new Error("Event name '" + name + "' not recognized");
        }
    },


	
	// Sample event handlers
	handleMouseEnter: function(sender, eventArgs) 
	{
		// The following code shows how to find an element by name and call a method on it.
		var mouseEnterAnimation = sender.findName(this._namePrefix + "mouseEnter");
		mouseEnterAnimation.begin(); 
	},
	
	handleMouseDown: function(sender, eventArgs) 
	{
		var mouseDownAnimation = sender.findName(this._namePrefix + "mouseDown");
		mouseDownAnimation.begin(); 
	},
	
	handleMouseUp: function(sender, eventArgs) 
	{
		var mouseUpAnimation = sender.findName(this._namePrefix + "mouseUp");
		mouseUpAnimation.begin(); 
		
        for (i in this._clickHandlers)
        {
          this._clickHandlers[i](this, {});
        }
	},
	
	handleMouseLeave: function(sender, eventArgs) 
	{
		var mouseLeaveAnimation = sender.findName(this._namePrefix + "mouseLeave");
		mouseLeaveAnimation.begin(); 
	}
}