var lastMessage = "";

function OnMediaEnded()
{
  lastMessage = "MediaEnded";
}

function OnMediaFailed()
{
  lastMessage = "MediaFailed";
}

function OnMediaMarkerReached(sender, eventArgs)
{
  lastMessage = "Marker reached: " + eventArgs.Marker.Text;
}

function OnMediaOpened(mediaElement)
{
  lastMessage = "MediaOpened, NaturalVideoWidth: " + mediaElement.NaturalVideoWidth +
   ", NaturalVideoHeight: " + mediaElement.NaturalVideoHeight +
   ", NaturalDuration: " + mediaElement.NaturalDuration.GetValue("Seconds").toFixed(4);

  var attributeList = document.getElementById("mediaAttributes");
  for(var i = 0; i < mediaElement.Attributes.Count; ++i)
  {
    var mediaAttribute = mediaElement.Attributes.GetItem(i);
    var li=document.createElement("li");
    li.innerHTML = "<p>Name: " + mediaAttribute.Name + ", Value: " + mediaAttribute.Value + "</p>";
    attributeList.appendChild(li);
  }
}



function OnMediaStateChange(mediaElement, eventArgs)
{
  var statusText = mediaElement.FindName("mediaStatus");

  var text = "CurrentState: " + mediaElement.CurrentState;
  text += ", BufferingProgress: " + mediaElement.BufferingProgress.toFixed(4);
  text += ", BufferingTime: " + mediaElement.BufferingTime.Seconds;
  text += ", DownloadProgress: " + mediaElement.DownloadProgress.toFixed(4);
  text += ", Position: " + mediaElement.Position.Seconds.toFixed(1);
  if (lastMessage != "")
  {
    text += "\n" + lastMessage;
  }

  statusText.Text = text;  
}

function OnLoad(control, eventArgs, rootElement)
{
  var content = control.Content;
  var timer = content.findName("timer");
  var mediaElement = content.FindName("media");

  timer.AddEventListener("Completed", OnTimer);
  timer.Begin();

  function OnTimer(storyboard, eventArgs)
  {
    OnMediaStateChange(mediaElement, eventArgs);
    timer.Begin();
  }
}
